(function()
{
	function _config(pObj, pEvent, pHandler)
	{
		if ( typeof pObj == 'object' )
		{
			if ( pEvent.substring(0, 2) == 'on' )
				pEvent = pEvent.substring(2, pEvent.length);

			if ( pObj.addEventListener )
				pObj.addEventListener(pEvent, pHandler, false);
			else if ( pObj.attachEvent )
				pObj.attachEvent('on' + pEvent, pHandler);
		}
	}

	if ( !(top.document.getElementById('instant_messenger_content')) )
	{
		var _im_content = top.document.createElement('div');
		_im_content.setAttribute('id', 'instant_messenger_content');
		_im_content = top.document.body.appendChild(_im_content);
	}

	var buffer = '';
	var _disconnected = false;

	var _conn = new IMConnector(path_im);
	var _xtools = new XTools(path_im);
	var _window = new Windows(_xtools, _im_content);
	var _ldap = new InstantMessengerLDAP(_conn, _xtools, _window);
	var _jabber = new Jabber(_conn, _xtools, _window, _ldap);

	// XSL preload
	var _xsl_preload = ['chat.xsl','layer.xsl','contacts'];
	var _xsl_preload_legth = _xsl_preload.length;
	for ( var i = 0; i < _xsl_preload_legth; i++ )
		_xtools.load(_xsl_preload[i]);

	var local;
	if ( (local = top.document.getElementById('user_info')) )
	{
		local.innerHTML = ' ' + local.innerHTML;
		var _status = top.document.createElement('img');
			_status.setAttribute('id','im_status_src');
			_status.src = im_available.src;

		local.insertBefore(_status, local.firstChild);

		_config(_status, 'onclick', _contacts);

		var _menu;
		_menu = top.document.createElement('span');
		_menu.setAttribute('id','fast_menu_im');
		local.insertBefore(_menu, local.firstChild);

		_menu = top.document.createElement('img');
		_menu.src = im_fast_menu.src;
		local.insertBefore(_menu, local.firstChild);

		//var local_old = local.innerHTML ;
		//local.innerHTML  = '<img src="' + im_fast_menu.src + '" onclick="javascript:templates.fast_menu();">';
		//local.innerHTML += '<img id="im_status_src" src="' + im_available.src + '" onclick="javascript:load_im_contacts();"/>';
		//local.innerHTML += local_old;
		//local.innerHTML += '<div id="instant_messenger_content"></div><span id="fast_menu_im"/>';
	}

	function _stream(data)
	{
		data = data.replace(/^ | $/, '');

		if ( !(data.length) )
			return false;

		if ( data.indexOf('disconnected') != -1 || data.indexOf('</stream:stream>') != -1 )
		{
			_disconnected = true;
			//alert('disconnected');
		}
		else
		{
			if ( data.lastIndexOf('>') != data.length - 1)
				buffer += data + ' ';
			else
			{
				if ( buffer.length )
				{
					data = buffer + data;
					buffer = '';
				}

				// com xmlns ocorre problemas durante o parse entre
				// xml e xsl e por esse motivo est sendo retirado
				data = data.replace(/ xmlns='.*?'/g, '');
				data = '<handler>' + data + '</handler>';

				var _xml = _xtools.convert(data);

				if ( _xml )
				{
					var _node = _xml.documentElement.firstChild;

					while ( _node )
					{
						if ( _node.nodeType == 1 )
							_jabber.action(_node);
						//else
						//	alert('name : ' + _node.nodeName + "\n\nhas children:" + _node.hasChildNodes() + "\nvalue\n\n" + _node.nodeValue);

						_node = _node.nextSibling;
					}
				}
			}
		}
	}

	function _request()
	{
		if ( !_disconnected )
			return _conn.go(
				'$this.Ujabber.listen',
				{'stream':_stream, 'request':_wait},
				'classCostructor=read'
			);
	}

	function _wait()
	{
		setTimeout(_request, 3000);
	}

	function _reconnect()
	{
		_disconnected = false;
		_request();
	}

	function _disconnect()
	{
		_disconnected = true;
	}

	function _contacts()
	{
		var _win = _window.get('contact_list');
		if ( _win )
			if ( _win.wm.style.display != 'none' )
				_win.wm.style.display = 'none';
			else
				_win.wm.style.display = 'block';
		else
			if ( !_disconnected )
				_conn.go('$this.Ujabber.getContacts');
	}

	function Client()
	{
		_request();
		setTimeout('InstantMessengerContacts()', 3000);
	}

	window.InstantMessengerClient = Client;
	window.InstantMessengerReconnect = _reconnect;
	window.InstantMessengerDisconnect = _disconnect;
	window.InstantMessengerContacts = _contacts;
}
)();
